web/src/openpaper/beacon/urls.py
# -*- coding: utf-8 -*-
from django.urls import path
from django.urls import re_path

from openpaper.beacon.views import bug_cluster_all
from openpaper.beacon.views import bug_cluster_graph
from openpaper.beacon.views import bug_cluster_mark_unread
from openpaper.beacon.views import bug_cluster_recompute
from openpaper.beacon.views import bug_cluster_toggle_solved
from openpaper.beacon.views import bug_cluster_view
from openpaper.beacon.views import bug_report_add_attachment
from openpaper.beacon.views import bug_report_create
from openpaper.beacon.views import bug_report_download_attachment
from openpaper.beacon.views import bug_report_index
from openpaper.beacon.views import bug_report_show
from openpaper.beacon.views import latest
from openpaper.beacon.views import post_statistics
from openpaper.beacon.views import raw_statistics
from openpaper.beacon.views import statistics
from openpaper.beacon.views import statistics_pie
from openpaper.beacon.views import statistics_historic


urlpatterns = [
    path('latest', latest, name='latest'),

    path('post_statistics', post_statistics, name='post_statistics'),
    path('statistics', statistics, name='statistics'),
    path(
        'statistics_historic', statistics_historic,
        name='statistics_historic'
    ),
    re_path(
        r'^statistics_historic'
        r';(?P<split>[a-zA-Z_]*)',
        statistics_historic, name='statistics_historic'
    ),
    path('statistics_pie', statistics_pie, name='statistics_pie'),
    re_path(
        r'^statistics_pie'
        r';(?P<unit>[a-z_]*)'
        r';(?P<min_docs>[0-9]*)'
        r';(?P<split>[a-zA-Z_]*)'
        r';(?P<filters>.*)$',
        statistics_pie, name='statistics_pie'
    ),
    path('raw_statistics', raw_statistics, name='raw_statistics'),

    path('bug_report', bug_report_index, name='bug_report_index'),
    path(
        'bug_report/create', bug_report_create,
        name='bug_report_create'
    ),
    path(
        'bug_report/add_attachment', bug_report_add_attachment,
        name="bug_report_add_attachment"
    ),
    path(
        'bug_report/show/<int:report_id>/<str:secret_key>',
        bug_report_show, name="bug_report_show"
    ),
    path(
        'bug_report/download/'
        '<int:report_id>/'
        '<str:secret_key>/'
        '<int:attachment_id>',
        bug_report_download_attachment, name="bug_report_download_attachment"
    ),

    path(
        'bug_cluster',
        bug_cluster_all,
        name="bug_cluster_all",
    ),
    path(
        'bug_cluster/<int:cluster_id>',
        bug_cluster_view,
        name="bug_cluster_view",
    ),
    path(
        'bug_cluster/<int:cluster_id>/mark_unread',
        bug_cluster_mark_unread,
        name="bug_cluster_mark_unread",
    ),
    path(
        'bug_cluster/<int:cluster_id>/toggle',
        bug_cluster_toggle_solved,
        name="bug_cluster_toggle_solved",
    ),
    path(
        'bug_cluster/<int:cluster_id>/traceback/<int:traceback_id>',
        bug_cluster_view,
        name="bug_cluster_traceback_view",
    ),
    path(
        'bug_cluster/recompute',
        bug_cluster_recompute,
        name="bug_cluster_recompute",
    ),
    path(
        'bug_cluster/graph/<str:graph_name>',
        bug_cluster_graph,
        name="bug_cluster_graph",
    ),
]

web/src/openpaper/urls.py
"""openpaper URL Configuration
"""
from django.conf.urls import include
from django.conf.urls.i18n import i18n_patterns
from django.contrib import admin
from django.contrib import sitemaps
from django.contrib.sitemaps.views import sitemap
from django.urls import (
    re_path,
    reverse
)


class RootViewSitemap(sitemaps.Sitemap):
    priority = 1.0
    changefreq = 'monthly'

    def items(self):
        return [
            'home:index',
        ]

    def location(self, item):
        return reverse(item)


class HighPriorityViewSitemap(sitemaps.Sitemap):
    priority = 0.75
    changefreq = 'monthly'

    def items(self):
        return [
        ]

    def location(self, item):
        return reverse(item)


class AveragePriorityViewSitemap(sitemaps.Sitemap):
    priority = 0.5
    changefreq = 'monthly'

    def items(self):
        return [
            'beacon:statistics',
            'home:opensource',
        ]

    def location(self, item):
        return reverse(item)


class LowPriorityViewSitemap(sitemaps.Sitemap):
    priority = 0.25
    changefreq = 'monthly'

    def items(self):
        return [
            'home:about',
        ]

    def location(self, item):
        return reverse(item)


sitemaps = {
    'root': RootViewSitemap,
    'high_prio': HighPriorityViewSitemap,
    'average_prio': AveragePriorityViewSitemap,
    'low_prio': LowPriorityViewSitemap,
}

urlpatterns = [
    re_path(r'^admin/', admin.site.urls),
    re_path(r'^api/', include('openpaper.api.urls')),
    re_path(r'^beacon/', include('openpaper.beacon.urls')),  # alias for Paperwork
    re_path(
        r'^dashboard/',
        include(('openpaper.dashboard.urls', 'dashboard'), namespace='dashboard')
    ),
    re_path(r'^i18n/', include('django.conf.urls.i18n')),
    # re_path(r'^robots\.txt', include('robots.urls')),
    re_path(  # alias for IronScanner
        r'^scannerdb/',
        include(
            ('openpaper.scannerdb.urls', 'scannerdb'),
            namespace="scannerdb_no_i18n"
        )
    ),
    re_path(
        r'^sitemap\.xml$', sitemap, {'sitemaps': sitemaps},
        name='django.contrib.sitemaps.views.sitemap'
    ),
]

urlpatterns += i18n_patterns(
    re_path(r'^', include(('openpaper.home.urls', 'home'), namespace='home')),
    re_path(
        r'^paperwork/',
        include(('openpaper.beacon.urls', 'beacon'), namespace='beacon')
    ),
    re_path(
        r'^scanner_db/',
        include(('openpaper.scannerdb.urls', 'scannerdb'), namespace='scannerdb')
    ),
)

web/src/openpaper/beacon/views.py
import base64
import datetime
import json
import logging
import re
import secrets
import string

import GeoIP
import ipware

from django.contrib.admin.views.decorators import staff_member_required
from django.core import serializers
from django.core.files.base import ContentFile
from django.core.mail import mail_admins
from django.db import transaction
from django.db.models import Count
from django.db.models import Sum
from django.http import Http404
from django.http import HttpResponse
from django.http import HttpResponseRedirect
from django.http import JsonResponse
from django.shortcuts import render
from django.urls import reverse
from django.utils.translation import gettext_lazy as _
from django.views.decorators.cache import cache_page
from django.views.decorators.csrf import csrf_exempt
from django.views.decorators.http import require_GET
from django.views.decorators.http import require_POST
import django.db

import openpaper.backend.msgqueue
import openpaper.backend.util

from .models import (
    BugCluster,
    BugReport,
    BugReportAttachment,
    Traceback,
    Statistics,
    StatsHistory,
    StatsHistoryOs,
    StatsHistoryVersion
)

LATEST_PAPERWORK_VERSION = "2.2.5"

STATS_MAX_DAYS = 40
STATS_MIN_DOCS = 50

LOGGER = logging.getLogger(__name__)

# Used on data automatically sent from Paperwork to avoid any possible XSS
STRICT_FILTER = re.compile("[^a-zA-Z0-9._ ():'-]")

GEOIP4_DB = geo = GeoIP.open(
    "/usr/share/GeoIP/GeoIP.dat", GeoIP.GEOIP_STANDARD
)
GEOIP6_DB = geo = GeoIP.open(
    "/usr/share/GeoIP/GeoIPv6.dat", GeoIP.GEOIP_STANDARD
)


UNKNOWN = "Unknown"


@require_GET
def latest(request):
    return JsonResponse({
        "paperwork": {
            "posix": LATEST_PAPERWORK_VERSION,
            "nt": LATEST_PAPERWORK_VERSION,
        },
    })


def cleanup():
    LOGGER.info(
        "Cleaning up date before: %s",
        str(datetime.date.today() - datetime.timedelta(days=STATS_MAX_DAYS))
    )
    Statistics.objects.filter(
        last_mod_date__lt=(
            datetime.date.today() - datetime.timedelta(days=STATS_MAX_DAYS)
        )
    ).delete()


def must_compile_stats():
    try:
        history = StatsHistory.objects.order_by("-creation_date")
        last = history[0]
        diff = datetime.datetime.now(
            datetime.timezone.utc
        ) - last.creation_date
        r = diff.days > 0
        LOGGER.info("must_compile_stats() ? %s", r)
        return r
    except (StatsHistory.DoesNotExist, IndexError):
        LOGGER.info("No stat compilations yet.")
        return True


def compile_stats():
    if not must_compile_stats():
        return

    nb_instances = Statistics.objects.filter(
        nb_documents__gte=STATS_MIN_DOCS
    ).count()
    max_docs = Statistics.objects.order_by('-nb_documents')[0].nb_documents
    total_docs = Statistics.objects.aggregate(
        Sum('nb_documents')
    )['nb_documents__sum']

    LOGGER.info(
        "nb_instances=%s, max_docs=%s, total_docs=%s",
        nb_instances, max_docs, total_docs
    )
    new_history = StatsHistory(
        nb_instances=nb_instances, max_docs=max_docs, total_docs=total_docs
    )
    new_history.save()

    versions = Statistics.objects.values('paperwork_version').annotate(Count(
        'paperwork_version'
    ))
    for version in versions:
        LOGGER.info("Versions: %s", version)
        h_version = StatsHistoryVersion(
            history=new_history,
            paperwork_version=version['paperwork_version'],
            count=version['paperwork_version__count']
        )
        h_version.save()

    oses = Statistics.objects.values('os_name').annotate(Count('os_name'))
    for o in oses:
        LOGGER.info("OS: %s", o)
        h_os = StatsHistoryOs(
            history=new_history,
            os_name=o['os_name'],
            count=o['os_name__count']
        )
        h_os.save()


def _strict_filter(string):
    if isinstance(string, int):
        return string
    return STRICT_FILTER.sub("", string)


def _get_country_from_ip(ip):
    if ip is None:
        return None
    if ":" in ip:
        return GEOIP6_DB.country_code_by_addr_v6(ip)
    else:
        return GEOIP4_DB.country_code_by_addr(ip)


@csrf_exempt
@require_POST
def post_statistics(request):
    django.db.close_old_connections()  # workaround for 'mysql has gone away'

    stats = request.POST['statistics']
    stats = json.loads(stats)
    stats = {
        k: _strict_filter(v)
        for (k, v) in stats.items()
    }

    LOGGER.info("Getting statistics")
    # We don't need the exact Paperwork version
    paperwork_version = stats['paperwork_version'].split("-", 1)[0]
    if ".dev" in paperwork_version:
        paperwork_version = paperwork_version.split(".dev", 1)[0]
        paperwork_version = paperwork_version.split(".")
        paperwork_version[-1] = str(int(paperwork_version[-1]) - 1)
        paperwork_version = ".".join(paperwork_version)
    if ".post" in paperwork_version:
        paperwork_version = paperwork_version.split(".post", 1)[0]
    paperwork_version = paperwork_version[:30]
    platform_processor = stats['platform_processor'][:14]

    if "flatpak" in stats.get('os_name'):
        stats['platform_distribution'] = 'Flatpak'
        stats['os_name'] = 'Linux'
    else:
        stats['os_name'] = stats.get('os_name').replace('nt', 'Windows')
        stats['os_name'] = stats.get('os_name').replace('posix', 'Linux')
        stats['platform_distribution'] = (
            stats.get('platform_distribution').split("'")[1]
        )

    stats['platform_architecture'] = (
        stats.get('platform_architecture').split("'")[1]
    )
    (ip, is_routable) = ipware.get_client_ip(request)
    country = _get_country_from_ip(ip)
    LOGGER.info("GeoIP: %s -> %s", ip, country)

    try:
        stats_obj = Statistics.objects.get(uuid=stats['uuid'])
        LOGGER.info("Statistics post: UUID=%s", stats['uuid'])
        stats_obj.paperwork_version = paperwork_version
        stats_obj.platform_processor = platform_processor
        for field in ['nb_documents',
                      'os_name', 'platform_architecture',
                      'platform_distribution']:
            LOGGER.info("%s=%s", field, stats.get(field))
            setattr(stats_obj, field, stats.get(field))
    except Statistics.DoesNotExist:
        stats_obj = Statistics(
            uuid=stats['uuid'],
            paperwork_version=paperwork_version,
            nb_documents=stats.get('nb_documents'),
            os_name=stats.get('os_name'),
            platform_architecture=stats.get('platform_architecture'),
            platform_processor=platform_processor,
            platform_distribution=stats.get('platform_distribution'),
            country=country,
        )
    stats_obj.save()

    cleanup()

    with transaction.atomic():
        compile_stats()

    return HttpResponse("OK")


def get_ranges(thresholds):
    for idx in range(0, len(thresholds) - 1):
        yield (
            "{}-{}".format(thresholds[idx], thresholds[idx + 1] - 1),
            (thresholds[idx], thresholds[idx + 1] - 1)
        )
    yield (
        "≥{}".format(thresholds[-1]),
        (thresholds[-1], None)
    )


class NoopFilterFactory(object):
    field = ''
    nice_name = _("All")

    def make(self, value, previous):
        return NoopFilter()


class NoopFilter(object):
    LINKABLE = False
    previous = None
    factory = NoopFilterFactory()

    def __init__(self, nice_name=None, count=-1):
        self.count = count
        self.nice_name = nice_name
        self.value = nice_name if nice_name is not None else _("All")

    def filter(self, queryset):
        return queryset

    def get_other_filter_names(self):
        r = set(KNOWN_FILTERS.keys())
        return r

    def __str__(self):
        return ''


class BaseFilter:
    def __init__(self, nice_name):
        self.nice_name = nice_name

    def get_other_filter_names(self):
        filters = self.previous.get_other_filter_names()
        filters.remove(self.factory.field)
        return filters

    def __str__(self):
        out = str(self.previous)
        if out != '':
            out += '|'
        out += "{}:{}".format(
            self.factory.field,
            self.value
        )
        return out


class ExactFilter(BaseFilter):
    LINKABLE = True

    def __init__(self, factory, value, previous, count=-1):
        super().__init__(value)
        self.factory = factory
        self.value = value
        self.previous = previous
        self.count = count

    def filter(self, queryset):
        value = self.value
        if value == str(UNKNOWN):
            value = None
        queryset = self.previous.filter(queryset)
        return queryset.filter(**{self.factory.field: value})


class RangeFilter(BaseFilter):
    LINKABLE = True

    def __init__(self, factory, min_val, max_val, previous, count=-1):
        self.factory = factory
        self.min_val = min_val
        self.max_val = max_val
        self.value = "{}-{}".format(self.min_val, self.max_val)
        super().__init__(self.value)
        self.previous = previous
        self.count = count

    def filter(self, queryset):
        queryset = self.previous.filter(queryset)
        return queryset.filter(**{
            self.factory.field + "__gte": self.min_val,
            self.factory.field + "__lte": self.max_val,
        })

    def get_other_filter_names(self):
        filters = self.previous.get_other_filter_names()
        filters.remove(self.factory.field)
        return filters

    def __str__(self):
        out = str(self.previous)
        if out != '':
            out += '|'
        out += "{}:{}".format(
            self.factory.field,
            self.value
        )
        return out


class GteFilter(BaseFilter):
    LINKABLE = True

    def __init__(self, factory, min_val, previous, count=-1):
        self.factory = factory
        self.min_val = min_val

web/src/openpaper/beacon/templates/bug_cluster_all.html
{% extends "base.html" %}

{% load static %}

{% block title %}Paperwork - Bug Report Clusters{% endblock %}

{% block extra_headers %}
{% endblock %}

{% block body %}
<h1>Bug Report Clusters</h1>

<p>
    <form action="{% url 'beacon:bug_cluster_recompute' %}" method="post">
        {% csrf_token %}
        <input type="submit" value="Recompute clusters" />
    </form>
</p>

<p>{{ nb_clusters }} clusters found.</p>
<p>Generated {{ generation_date }}.</p>

<p>
  <a href="{% url 'beacon:bug_cluster_graph' 'decomp' %}">
    <img style="width: 45%;" src="{% url 'beacon:bug_cluster_graph' 'decomp' %}" />
  </a>
  <a href="{% url 'beacon:bug_cluster_graph' 'clustering' %}">
    <img style="width: 45%;" src="{% url 'beacon:bug_cluster_graph' 'clustering' %}" />
  </a>
  <a href="{% url 'beacon:bug_cluster_graph' 'cluster_sizes' %}">
    <img style="width: 45%;" src="{% url 'beacon:bug_cluster_graph' 'cluster_sizes' %}" />
  </a>
</p>

<p>
{% for p in pages %}
<a href="{% url 'beacon:bug_cluster_all' %}?page={{ p }}">
{% if p == page_nb %}
<strong>{{ p|add:1 }}</strong>
{% else %}
{{ p|add:1 }}
{% endif %}
</a>
{% endfor %}
</p>

<table>
  <tr>
    <th>Cluster ID</th>
    <th>Paperwork version</th>
    <th>Nb of tracebacks</th>
    <th>Latest report</th>
    <th>Solved</th>
  </tr>

{% for cluster in clusters %}
  <tr>
    <td>
      {% if not cluster.read %}<strong>{% endif %}
      <a href="{% url "bug_cluster_view" cluster.id %}">#{{ cluster.id }}</a>
      {% if not cluster.read %}</strong>{% endif %}
    </td>
    <td>
      {% if not cluster.read %}<strong>{% endif %}
      <a href="{% url "bug_cluster_view" cluster.id %}">{{ cluster.latest_paperwork_version }}</a>
      {% if not cluster.read %}</strong>{% endif %}
    </td>
    <td>
      {% if not cluster.read %}<strong>{% endif %}
      <a href="{% url "bug_cluster_view" cluster.id %}">{{ cluster.nb_tracebacks }}</a>
      {% if not cluster.read %}</strong>{% endif %}
    </td>
    <td>
      {% if not cluster.read %}<strong>{% endif %}
      <a href="{% url "bug_cluster_view" cluster.id %}">{{ cluster.latest_report.creation_date }}</a>
      {% if not cluster.read %}</strong>{% endif %}
    </td>
    <td>
      {% if cluster.solved %}
      <center>
        <a href="{% url "bug_cluster_view" cluster.id %}">
          <img alt="yes" src="{% static "checkbox-checked-symbolic.symbolic.png" %}" />
        </a>
      </center>
      {% endif %}
    </td>
  </tr>
{% endfor %}

</table>

{% endblock %}

web/src/openpaper/beacon/templates/bug_cluster_view.html
{% extends "base.html" %}

{% load static %}

{% block extra_headers %}
<link rel="stylesheet" href="{% static "openpaper_bugcluster.css" %}">
{% endblock %}

{% block title %}Paperwork - Bug Report Cluster #{{ cluster.id }}{% endblock %}

{% block body %}

<h1><a href="{% url "bug_cluster_all" %}">Bug Report Clusters</a> &gt; #{{ cluster.id }}</h1>

<div id="bugcluster_listing">
  <h2>Tracebacks</h2>
  <p>{{ cluster.nb_tracebacks }} tracebacks</p>
  <ul>
{% for other_traceback in cluster.tracebacks %}
    {% if traceback and traceback.id == other_traceback.id %}
    <strong>
    {% endif %}
    <li><a href="{% url "bug_cluster_traceback_view" cluster.id other_traceback.id %}">#{{ other_traceback.id }}</a></li>
    {% if traceback and traceback.id == other_traceback.id %}
    </strong>
    {% endif %}
{% endfor %}
  </ul>
</div>

<div id="bugcluster_body">
  <p>
    <form action="{% url 'beacon:bug_cluster_toggle_solved' cluster.id %}" method="post">
      {% csrf_token %}
{% if cluster.solved %}
      <input type="submit" value="Unsolve" />
{% else %}
      <input type="submit" value="Solve" />
{% endif %}
    </form>

    <form action="{% url 'beacon:bug_cluster_mark_unread' cluster.id %}" method="post">
      {% csrf_token %}
      <input type="submit" value="Mark unread" />
    </form>
  </p>

  {% if not traceback %}
  <p>No traceback selected</p>
  {% else %}
  <h2>Traceback #{{ traceback.id }}</h2>

  <ul>
    <li>Report:
      <a href="{% url "bug_report_show" traceback.log_file.bug_report.id traceback.log_file.bug_report.secret_key %}">
        #{{ traceback.log_file.bug_report.id }}
      </a>
    </li>
    <li>Attachment:
      <a href="{% url "bug_report_download_attachment" traceback.log_file.bug_report.id traceback.log_file.bug_report.secret_key traceback.log_file.id %}">
        {{ traceback.log_file.file_name }}
      </a>
    </li>
    <li>Lines: {{ traceback.line_start }} - {{ traceback.line_end }}</li>
  </ul>

  <pre>{{ traceback.content }}</pre>
  {% endif %}
</div>

{% endblock %}

web/src/openpaper/beacon/templates/bug_report_index.html
{% extends "base.html" %}

{% load static %}

{% block title %}Paperwork - Bug Reports{% endblock %}

{% block extra_headers %}
{% endblock %}

{% block body %}
<h1>Bug Reports</h1>

<p>
{% for p in pages %}
<a href="{% url 'beacon:bug_report_index' %}?page={{ p }}">
{% if p == page_nb %}
<strong>{{ p|add:1 }}</strong>
{% else %}
{{ p|add:1 }}
{% endif %}
</a>
{% endfor %}
</p>

<ul>
{% for report in reports %}
<li>
    {% if not report.read %}<strong>{% endif %}
    <a href="{% url 'beacon:bug_report_show' report.id report.secret_key %}">{{ report }}</a>
    {% if not report.read %}</strong>{% endif %}
</li>
{% endfor %}
</ul>

{% endblock %}

web/src/openpaper/beacon/templates/bug_report_show.html
{% extends "base.html" %}

{% load static %}

{% block title %}Paperwork - Bug Report {{ report.creation_date }}{% endblock %}

{% block extra_headers %}
{% endblock %}

{% block body %}
<h1>Bug report</h1>

<ul>
    <li>Date: {{ report.creation_date }}</li>
    <li>Application: {{ report.app_name }}</li>
    <li>Application version: {{ report.app_version }}</li>
</ul>

{% if user.is_authenticated %}
<h2>Admin</h2>

<ul>
    <li><a href="{% url "beacon:bug_report_index" %}">Back to the bug report list</a></li>
    <li><a href="{% url "admin:beacon_bugreport_change" report.id %}">Administration interface</a></li>
</ul>
{% endif %}

<h2>Attachments</h2>

<ul>
{% for attachment in attachments %}
<li>
    <a href="{% url 'beacon:bug_report_download_attachment' report.id report.secret_key attachment.id %}">{{ attachment.file_name }}</a>
</li>
{% endfor %}
</ul>

{% endblock %}

web/src/openpaper/beacon/templates/statistics.html
{% extends "base.html" %}

{% load i18n %}
{% load static %}

{% block title %}{% trans "Paperwork - Usage statistics" %}{% endblock %}

{% block extra_headers %}
<style>
ul {
    padding-left: 30px;
    padding-top: 30px;
    padding-bottom: 50px;
}

ul li {
    padding-top: 30px;
    font-size: 1.25em;
}
</style>
{% endblock %}

{% block body %}
<h1>{% trans "Paperwork usage statistics" %}</h1>

<ul>
    <li><a href="{% url 'beacon:statistics_pie' %}">{% trans "Current statistics" %}</a></li>
    <li><a href="{% url 'beacon:statistics_historic' %}">{% trans "Historic" %}</a></li>
</ul>

{% blocktrans %}
<h2>Statistics sources</h2>
<p>Only users that <em>enabled anonymous statistics</em> to be sent are taken into account here.</p>
<p>Paperwork instances send statistics about once a week.</p>
<p>Statistics are kept at most {{ stats_kept }} days since their last update.</p>
<p>IP addresses are not stored in the database. Only system UUIDs.</p>
{% endblocktrans %}

<h2 id="raw">{% trans "Raw statistics" %}</h2>

{% url 'beacon:raw_statistics' as raw_stats %}
{% blocktrans %}
<p>Raw statistics can be downloaded <a href="{{ raw_stats }}">here</a>.</p>
{% endblocktrans %}

{% endblock %}

web/src/openpaper/beacon/templates/statistics_historic.html
{% extends "base.html" %}

{% load i18n %}
{% load static %}
{% load stats %}

{% block title %}{% trans "Paperwork - Usage statistics" %}{% endblock %}

{% block extra_headers %}

<script src="{% static "chart.umd.js" %}"></script>

<style>
hr {
    margin: 2em auto;
}

h2 {
    margin-bottom: 20px;
}

#selectors {
    text-align: center;
}

.selector {
    display: inline-block;
    white-space: nowrap;
    line-height: 40px;
    font-size: 0.75em;
}

.selector_left, .selector_middle, .selector_right {
    border: 1px solid gray;
    margin-right: 10px;
    padding: 4px 9px 4px 9px;
    text-decoration: none;
    color: gray;
    background-image: radial-gradient(at top left, #ffffff, #f9f9f9 75%);
}
.selector_left:hover, .selector_right:hover {
    color: black;
}

.selector_selected {
    background-image: radial-gradient(at top left, #ffffff, #89abcd 75%);
    cursor: default;
    color: black;
    padding: 5px 10px 5px 10px;
}
.selector_selected:hover {
    color: black;
    text-decoration: none;
}

.selector_left {
    margin-right: 0px;
    border-right: 0px;
    border-radius: 10px 0px 0px 10px;
}

.selector_right {
    margin-left: 0px;
    border-radius: 0px 10px 10px 0px;
}

.selector_middle {
    margin-left: 0px;
    margin-right: 0px;
    border-right: 0px;
    border-radius: 0px 0px 0px 0px;
}

#graphs {
    text-align: left;
    border-top: 1px solid black;
    display: inline-block;
    vertical-align: top;
    height: 400px;
    padding: 50px;
}

</style>

{% endblock %}

{% block body %}
<h1>
<a href="{% url 'beacon:statistics' %}">{% trans "Paperwork usage statistics" %}</a>
&gt; {% trans "Historic" %}
</h1>

<hr/>

<div id="graph_and_next">

    <p id="selectors">
        <span class="selector">
            <a href="{% stats_url_switch settings 'split' '' %}"
                class="selector_left
                    {% if settings.split == '' %}
                    selector_selected
                    {% endif %}
                    ">
                {% trans "≥ 50 docs" %}
            </a>
            <a href="{% stats_url_switch settings 'split' 'docs' %}"
                class="selector_middle
                    {% if settings.split == 'docs' %}
                    selector_selected
                    {% endif %}
                    ">
                {% trans "documents" %}
            </a>
            <a href="{% stats_url_switch settings 'split' 'os' %}"
                class="selector_middle
                    {% if settings.split == 'os' %}
                    selector_selected
                    {% endif %}
                    ">
                {% trans "OSes" %}
            </a>
            <a href="{% stats_url_switch settings 'split' 'version' %}"
                class="selector_right
                    {% if settings.split == 'version' %}
                    selector_selected
                    {% endif %}
                    ">
                {% trans "versions" %}
            </a>
        </span>
    </p>

    <div>
        <canvas id="graph"></canvas>
        <script>
(async function() {
    new Chart(
        document.getElementById('graph'),
        {
            type: 'line',
            data: {
                labels: [
                    {% for d in labels %}'{{ d|date }}',
                    {% endfor %}
                ],
                datasets: JSON.parse("{{datasets|escapejs}}")
            },
            options: {
                animation: false
            }
        }
    );
})();
        </script>
    </div>

</div>

{% endblock %}